package robot;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.RenderingHints;
import java.awt.GradientPaint;
import java.awt.Dimension;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import java.io.*;
import javax.swing.JLabel;
import javax.swing.JTextArea;

public class robot1 extends JComponent implements rozhranie,ActionListener {
    /**vytvara zakladne graficke okno
     */
    JButton G_spustac;
    draha draha;
    JLabel L_nazov_suboru;
    JTextArea TA_nazov_suboru;
    JLabel L_poc_sur ;
    JTextArea TA_poc_x;
    JTextArea TA_poc_y;
    JLabel L_poc_smer;
    JTextArea TA_poc_smer_x;
    JTextArea TA_poc_smer_y;
    Component f;
    public robot1() throws IOException{
          JFrame hl_ram = new JFrame("Draha robota");
          hl_ram.setBounds(25, 25, 1000,700);            //velkost okna
          hl_ram.setResizable(false);         //pevna velkost okna
          hl_ram.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

          draha = new draha();
          draha.setBounds(5, 5, 950, 500);
          hl_ram.add(draha);

          G_spustac = new JButton("načítaj a vykresli");
          G_spustac.setBounds(20, 620, 150, 30);
          G_spustac.addActionListener(this);
          hl_ram.add(G_spustac);

          L_nazov_suboru =new JLabel("názov súboru");
          L_nazov_suboru.setBounds(20, 550, 150, 30);
          hl_ram.add(L_nazov_suboru);

          TA_nazov_suboru = new JTextArea();
          TA_nazov_suboru.setBounds(20, 580, 150, 30);
          hl_ram.add(TA_nazov_suboru);

          L_poc_sur =new JLabel("počiatočné súradnice (x, y)");
          L_poc_sur.setBounds(200, 550, 200, 30);
          hl_ram.add(L_poc_sur);

          TA_poc_x = new JTextArea();
          TA_poc_x.setBounds(200, 580, 40, 30);
          TA_poc_x.setText("700");
          hl_ram.add(TA_poc_x);

          TA_poc_y = new JTextArea();
          TA_poc_y.setBounds(250, 580, 40, 30);
          TA_poc_y.setText("200");
          hl_ram.add(TA_poc_y);

          L_poc_smer =new JLabel("počiatočný smer (x, y)");
          L_poc_smer.setBounds(400, 550, 200, 30);
          hl_ram.add(L_poc_smer);

          TA_poc_smer_x = new JTextArea();
          TA_poc_smer_x.setBounds(400, 580, 40, 30);
          TA_poc_smer_x.setText("-1");
          hl_ram.add(TA_poc_smer_x);

          TA_poc_smer_y = new JTextArea();
          TA_poc_smer_y.setBounds(450, 580, 40, 30);
          TA_poc_smer_y.setText("0");
          hl_ram.add(TA_poc_smer_y);

          hl_ram.setLayout(null);
          hl_ram.setVisible(true);
    }
         public void actionPerformed(ActionEvent e) {
            if(e.getSource()==G_spustac) {
            try {
                nacitanie(TA_nazov_suboru.getText());
                vstup_TA[1]=TA_poc_x.getText();
                vstup_TA[2]=TA_poc_y.getText();
                vstup_TA[3]=TA_poc_smer_x.getText();
                vstup_TA[4]=TA_poc_smer_y.getText();
                draha.repaint();
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(f,"Nazov suboru je zly. "
                        + "Subor umiestnite do adresara robot. Treba pripisat aj priponu!");
            }
            }
    }

         public static void main(String[] args) throws IOException {
        vstup_TA[1]="700";
        vstup_TA[2]="200";
        vstup_TA[3]="-1";
        vstup_TA[4]="0";
        vystup_file[1]='$';
        new robot1();
    }
/** nacita subor a pripravi hodnoty na vykreslovanie do pola vystup_file */
    public static void nacitanie(String nazov) throws IOException{
        int pocl=0,pocr=0,pocp=0;
        int dlzkaseturiadkov=20;            //urcuje po kolko riadkov sa spracuvava subor
        String s;
        char[] pom= new char[10];           //sluzi na prevod vstupneho stringu na char koli case
        int i=1;
        int pkrokov=1;
        File vstup = new File(nazov);
           BufferedReader br = new BufferedReader(new FileReader(vstup));
            s = br.readLine();
            while(s!=null) {
            i=1; pocl=0;pocp=0;pocr=0;
                while (i<=dlzkaseturiadkov && s!=null){      // v tomto cykle sa nacita 100 znakov
                if(s.length()>0)  s.getChars(0, 1, pom, 1); //osetrenie aby pri nahodne nulovom riadku nezastal
                    switch (pom[1]){
                        case('l'): pocl++;break;
                        case('p'): pocp++;break;
                        case('r'): pocr++;break;
                    }
                s = br.readLine();
                i++;
                }
            vystup_file[pkrokov]='r';
            if(pocp>pocl) vystup_file[pkrokov]='p';
            else if(pocl>pocr) vystup_file[pkrokov]='l';         // tu sa zo "dlzkaseturiadkov" znakov vyberie najpocetnejsi
            pkrokov++;
            }
            br.close();
        vystup_file[pkrokov]='$';
        vystup_file[pkrokov+1]='$';
        }
}
interface rozhranie{
      char[] vystup_file=new char[10000];       //vystupne pole. Najpocetnejsi znak z bloku po ktorych sa nacitava
      String[] vstup_TA= new String[10];        //field of inputs from text areas
      // 1 - pocx; 2 - pocy; 3 - poc smer x; 4 - poc smer y;
}